config/routes.rb
# frozen_string_literal: true

require 'sidekiq/web'
require 'sidekiq-scheduler/web'

Rails.application.routes.draw do
  authenticate :admin do
    mount Sidekiq::Web => '/sidekiq'
    # mount LetterOpenerWeb::Engine, at: "/letter_opener"
  end

  devise_scope :user do
    get '/admin_sign_in', to: "decidim/devise/sessions#new"
  end

  mount LetterOpenerWeb::Engine, at: '/letter_opener' if Rails.env.development?

  mount Decidim::Core::Engine => '/'
  # mount Decidim::Map::Engine => '/map'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/decidim_controller.rb
# Entry point for Decidim. It will use the `DecidimController` as
# entry point, but you can change what controller it inherits from
# so you can customize some methods.
class DecidimController < ApplicationController
  before_action :set_raven_context

  private

  def set_raven_context
    return unless Rails.application.secrets.dig(:sentry, :enabled)
    Raven.user_context({id: try(:current_user).try(:id)}.merge(session))
    Raven.extra_context(params: params.to_unsafe_h, url: request.url)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/decidim/badge_helper.rb
# frozen_string_literal: true

module Decidim
  # Helpers related to icons
  module BadgeHelper
    def badges
      badges = []

      if respond_to?(:officialized?) && officialized?
        badges << "verified-badge"
      end

      if respond_to?(:officialized?) && eid_verified?
        badges << "eid-verified"
      end

      badges
    end
  end
end

app/views/analytics/_hotjar.html.erb
<% if Rails.application.secrets.dig(:hotjar).present? && Rails.application.secrets.dig(:hotjar, :enabled) %>
  <!-- Hotjar Tracking Code for https://crowbar.osp.cat/ -->
  <script>
      (function (h, o, t, j, a, r) {
          h.hj = h.hj || function () {
              (h.hj.q = h.hj.q || []).push(arguments)
          };
          h._hjSettings = {hjid: <%= Rails.application.secrets.dig(:hotjar, :site_id) %>, hjsv: 6};
          a = o.getElementsByTagName('head')[0];
          r = o.createElement('script');
          r.async = 1;
          r.src = t + h._hjSettings.hjid + j + h._hjSettings.hjsv;
          a.appendChild(r);
      })(window, document, 'https://static.hotjar.com/c/hotjar-', '.js?sv=');
  </script>
<% end %>

app/views/decidim/admin/officializations/index.html.erb
<div class="filters row">
  <div class="column medium-3">
    <span class="dropdown-menu-inverted_label"><%= t(".filter_by") %> :</span>
    <ul class="dropdown menu dropdown-inverted" data-dropdown-menu data-close-on-click-inside="false">
      <li class="is-dropdown-submenu-parent">
        <a href="#">
          <% if @state.present? %>
            <%= t(".filter.#{@state}") %>
          <% else %>
            <%= t(".filter.all") %>
          <% end %>
        </a>
        <ul class="menu is-dropdown-submenu">
          <li><%= link_to t(".filter.officialized"), url_for(state: "officialized", q: @query) %></li>
          <li><%= link_to t(".filter.not_officialized"), url_for(state: "not_officialized", q: @query) %></li>
          <li><%= link_to t(".filter.all"), url_for(q: @query) %></li>
        </ul>
      </li>
    </ul>
  </div>
  <div class="column medium-4">
    <%= form_tag "", method: :get do %>
      <div class="filters__search">
        <div class="input-group">
          <%= search_field_tag :q, @query,label: false, class: "input-group-field", placeholder: t(".search") %>
          <%= hidden_field_tag :state, @state %>
          <div class="input-group-button">
            <button type="submit" class="button button--muted">
              <%= icon "magnifying-glass", aria_label: t(".search") %>
            </button>
          </div>
        </div>
      </div>
    <% end %>
  </div>
</div>

<div class="card" id='user-groups'>
  <div class="card-divider">
    <h2 class="card-title"><%= t "decidim.admin.titles.participants" %></h2>
  </div>
  <div class="card-section">
    <div class="table-scroll">
      <table class="table-list">
        <thead>
        <tr>
          <th><%= t(".name") %></th>
          <th><%= t(".nickname") %></th>
          <th><%= t(".created_at") %></th>
          <th><%= t(".status") %></th>
          <th><%= t(".badge") %></th>
          <th><%= t(".actions") %></th>
        </tr>
        </thead>
        <tbody>
          <% @users.each do |user| %>
            <tr data-user-id="<%= user.id %>">
              <% if user.nickname.present? %>
                <td><%= link_to user.name, decidim.profile_path(user.nickname) %></td>
                <td><%= link_to user.nickname, decidim.profile_path(user.nickname) %></td>
              <% else %>
                <td><%= user.name %></td>
                <td><%= user.nickname %></td>
              <% end %>
              <td><%= l user.created_at, format: :short %></td>
              <td><%= user.officialized? ? t(".officialized") : t(".not_officialized") %></td>
              <td>
                <%= translated_attribute(user.officialized_as) %>
                <% if user.eid_verified? %>
                  <span class="author__badge">
                    <%= external_icon 'icon-eid-verified.svg' %>
                  </span>
                <% end %>
              </td>

              <td class="table-list__actions">
                <%= icon_link_to "envelope-closed", current_or_new_conversation_path_with(user), t("decidim.contact"), class:"action-icon--new" %>
                <% if user.officialized? %>
                  <%= icon "circle-check", class: "action-icon action-icon--disabled" %>
                  <%= icon_link_to "pencil", new_officialization_path(user_id: user.id), t(".reofficialize"), class: "action-icon--new" %>
                  <%= icon_link_to "circle-x", officialization_path(user.id), t(".unofficialize"), method: :delete, class: "action-icon--reject" %>
                <% else %>
                  <%= icon_link_to "circle-check", new_officialization_path(user_id: user.id), t(".officialize"), class: "action-icon--verify" %>
                  <%= icon "pencil", class: "action-icon action-icon--disabled" %>
                  <%= icon "circle-x", class: "action-icon action-icon--disabled" %>
                <% end %>
              </td>
            </tr>
          <% end %>
        </tbody>
      </table>
      <%= paginate @users, theme: "decidim" %>
    </div>
  </div>
</div>

app/views/decidim/shared/_login_modal.html.erb
<div class="reveal" id="loginModal" data-reveal>
  <div class="reveal__header">
    <h3 class="reveal__title"><%= t(".please_sign_in") %></h3>
    <button class="close-button" data-close aria-label="Close modal"
            type="button">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <% if current_organization.sign_in_enabled? %>
    <%= render partial: "decidim/devise/shared/omniauth_buttons_mini", cached: true %>
    <div class="row">
      <div class="columns medium-8 medium-centered">
        <%= decidim_form_for(Decidim::User.new, as: :user, url: session_path(:user), html: { class: "register-form new_user" }) do |f| %>
          <div>
            <div class="field">
              <%= f.email_field :email, autofocus: true %>
            </div>
            <div class="field">
              <%= f.password_field :password, autocomplete: "off" %>
            </div>
          </div>
          <div class="actions">
            <%= f.submit t("devise.sessions.new.sign_in"), class: "button expanded" %>
          </div>
        <% end %>
        <% if current_organization.sign_up_enabled? %>
          <p class="text-center">
            <%= link_to t(".sign_up"), decidim.new_user_registration_path, class: "sign-up-link" %>
          </p>
        <% end %>
        <p class="text-center">
          <%= link_to t("devise.shared.links.forgot_your_password"), new_password_path(:user) %>
        </p>
      </div>
    </div>
  <% else %>
    <div class="row">
      <div class="columns medium-8 medium-centered">
        <p>
          <%= t("sign_in_disabled", scope: "decidim.devise.sessions.new") %>
        </p>
      </div>
    </div>
    <%= render partial: "decidim/devise/shared/omniauth_buttons", cached: true %>
  <% end %>
</div>

app/views/layouts/decidim/_application.html.erb
<% add_decidim_meta_tags({
                             description: strip_tags(translated_attribute(current_organization.description)),
                             title: current_organization.name,
                             url: request.original_url,
                             twitter_handler: current_organization.twitter_handler,
                             image_url: Decidim::ContentBlock.published.find_by(
                                 organization: current_organization,
                                 scope: :homepage,
                                 manifest_name: :hero
                             ).try(:images_container).try(:background_image).try(:url)
                         }) %>

<!DOCTYPE html>
<html lang="<%= I18n.locale %>" class="no-js">
<head>
  <title><%= decidim_page_title %></title>
  <%= render partial: "layouts/decidim/head" %>
</head>

<body>
<%= render partial: "layouts/decidim/impersonation_warning" %>
<%= render partial: "layouts/decidim/cookies" %>
<%= render partial: "layouts/decidim/omnipresent_banner" %>

<%= render "layouts/decidim/wrapper" do %>
  <%= yield %>
<% end %>

<% cache current_organization do %>
  <%= render partial: "decidim/shared/login_modal" %>
<% end %>
<%= render partial: "decidim/shared/authorization_modal" %>
<script type="text/javascript">
    window.Decidim.locale = "<%= I18n.locale.to_s.html_safe %>";
    window.Decidim.locale_name = "<%= t("name", scope: "locale") %>";
    window.Decidim.available_locales = <%= current_organization.available_locales.to_json.html_safe %>;
    window.Decidim.translatable = <%= (!current_organization.deepl_api_key.blank? && current_organization.translatable_locales.count > 1).to_s %>;
    window.Decidim.translatable_locales = <%= current_organization.translatable_locales.to_json.html_safe %>;
</script>
</body>
</html>

app/views/layouts/decidim/_head_extra.html.erb
<% if Rails.application.secrets.dig(:sentry, :enabled) %>
  <script src="https://browser.sentry-cdn.com/<%= Rails.application.secrets.dig(:sentry, :js_version) %>/bundle.min.js" crossorigin="anonymous"></script>
  <script>
    Sentry.init({
      dsn: '<%= Rails.application.secrets.dig(:sentry, :dsn) %>'
    });
  </script>
<% end %>

app/views/layouts/decidim/_social_media_links.html.erb
<ul class="main__footer__social footer-social">
  <% if current_organization.twitter_handler.present? %>
    <li>
      <a class="footer-social__icon" target="_blank" title="Twitter" href="https://twitter.com/<%= current_organization.twitter_handler %>">
        <%= icon "twitter", role: "img", aria_label: "Twitter" %>
      </a>
    </li>
  <% end %>
  <% if current_organization.facebook_handler.present? %>
    <li>
      <a class="footer-social__icon" target="_blank" title="Facebook" href="https://www.facebook.com/<%= current_organization.facebook_handler %>">
        <%= icon "facebook", role: "img", aria_label: "Facebook" %>
      </a>
    </li>
  <% end %>
  <% if current_organization.instagram_handler.present? %>
    <li>
      <a class="footer-social__icon" target="_blank" title="Instagram" href="https://www.instagram.com/<%= current_organization.instagram_handler %>">
        <%= icon "instagram", role: "img", aria_label: "Instagram" %>
      </a>
    </li>
  <% end %>
  <% if current_organization.youtube_handler.present? %>
    <li>
      <a class="footer-social__icon" target="_blank" title="YouTube" href="https://www.youtube.com/<%= current_organization.youtube_handler %>">
        <%= icon "youtube", role: "img", aria_label: "YouTube" %>
      </a>
    </li>
  <% end %>
  <% if current_organization.github_handler.present? %>
    <li>
      <a class="footer-social__icon" target="_blank" title="GitHub" href="https://www.github.com/<%= current_organization.github_handler %>">
        <%= icon "github", role: "img", aria_label: "GitHub" %>
      </a>
    </li>
  <% end %>
</ul>

app/views/layouts/decidim/_wrapper.html.erb
<%
if respond_to?(:current_component) && current_component && can_be_managed?(current_component)
  edit_link(
    manage_component_path(current_component),
    :read,
    :component,
    component: current_component,
    current_participatory_space: current_participatory_space
  )
end
%>

<div class="off-canvas-wrapper" id="app">
  <div class="off-canvas-wrapper-inner" data-off-canvas-wrapper>
    <div class="off-canvas position-right hide-for-large" data-position="right"
         id="offCanvas" data-off-canvas>
      <!-- Close button -->
      <button class="close-button"
              aria-label="<%= t("layouts.decidim.header.close_menu") %>" type="button"
              data-close>
        <span aria-hidden="true">&times;</span>
      </button>
      <!-- Menu -->
      <div class="hide-for-medium" data-set="nav-holder"></div>
      <div class="hide-for-medium usermenu-off-canvas-holder"
           data-set="nav-login-holder"></div>
    </div>
    <div class="off-canvas-content" data-off-canvas-content>
      <div class="footer-separator">
        <!--separates the footer from the rest of the page,
             creates a sticky footer-->
        <!-- Topbar -->
        <div class="title-bar">
          <% if current_organization.official_img_header? %>
            <%= link_to  current_organization.official_url, class: "logo-cityhall" do %>
              <%= image_tag current_organization.official_img_header.url.to_s , alt: current_organization.name %>
            <% end %>
          <% end %>
          <div class="row column topbar">
            <div class="logo-wrapper">
              <%= render partial: "layouts/decidim/logo", locals: { organization: current_organization } %>
            </div>
            <%= render partial: "layouts/decidim/topbar_search" %>
            <%= render partial: "layouts/decidim/language_chooser" %>
            <div class="hide-for-medium topbar__menu">
              <button type="button" data-toggle="offCanvas">
                <%= icon "menu", aria_label: t("layouts.decidim.header.navigation"), role: "img" %>
              </button>
            </div>
            <% if current_user %>
              <div class="topbar__dropmenu topbar__user__logged">
                <%= link_to decidim.notifications_path, class: "topbar__notifications #{current_user.notifications.any? ? "is-active" : ""}" do %>
                  <%= icon "bell" %>
                <% end %>
                <%= link_to decidim.conversations_path, class: "topbar__conversations #{current_user.unread_conversations.any? ? "is-active" : ""}" do %>
                  <%= icon "envelope-closed" %>
                <% end %>
                <ul class="dropdown menu" data-dropdown-menu>
                  <li class="is-dropdown-submenu-parent show-for-medium">
                    <%= link_to current_user.name, decidim.account_path %>
                    <ul class="menu is-dropdown-submenu js-append usermenu-off-canvas">
                      <%= render partial: "layouts/decidim/user_menu" %>
                    </ul>
                    <span data-set="nav-login-holder" class="show-for-medium">
                      <!-- Repeated due to dropdown limitations -->
                      <ul class="menu is-dropdown-submenu js-append usermenu-off-canvas">
                        <%= render partial: "layouts/decidim/user_menu" %>
                      </ul>
                    </span>
                  </li>
                </ul>
              </div>
            <% else %>
              <div class="topbar__user show-for-medium" data-set="nav-login-holder">
                <div class="topbar__user__login js-append">
                  <% if current_organization.sign_up_enabled? %>
                    <%= link_to t("layouts.decidim.header.sign_up"), decidim.new_user_registration_path, class: "sign-up-link" %>
                  <% end %>
                  <%= link_to t("layouts.decidim.header.sign_in"), decidim.new_user_session_path, class: "sign-in-link" %>
                </div>
              </div>
            <% end %>
            <%= render partial: "layouts/decidim/edit_link" %>
          </div>
        </div>
        <div class="show-for-medium" data-set="nav-holder">
          <nav class="navbar js-append">
            <div class="row column">
              <%= main_menu.render %>
            </div>
          </nav>
        </div>

        <main>
          <%= display_flash_messages %>
          <%= yield %>
        </main>
      </div><!-- /.footer-separator -->
      <div class="main-footer">
        <div class="row">
          <div class="footer-logo">
            <% if current_organization.official_img_footer? %>
              <%= link_to  current_organization.official_url, class: "main-footer__badge" do %>
                <%= image_tag current_organization.official_img_footer.url.to_s , alt: current_organization.name %>
              <% end %>
            <% end %>
          </div>
          <ul class="main__footer__nav footer-nav">
            <% if current_organization.static_pages.any? %>
              <% current_organization.static_page_topics.where(show_in_footer: true).each do |page_topic| %>
                <% if page_topic.pages.any? %>
                  <li><%= link_to translated_attribute(page_topic.title), decidim.page_path(page_topic.pages.first) %></li>
                <% end %>
              <% end %>

              <% current_organization.static_pages.where(show_in_footer: true).each do |page| %>
                <li><%= link_to translated_attribute(page.title), decidim.page_path(page) %></li>
              <% end %>
            <% end %>
            <li><%= link_to t("layouts.decidim.footer.download_open_data"), decidim.open_data_download_path %></li>
            <% if cookies_accepted? %>
              <li><%= link_to t("layouts.decidim.footer.revoke_cookies"), "#", class: "reset-button" %></li>
            <% end %>
          </ul>
          <%= render partial: "layouts/decidim/social_media_links" %>
        </div>
      </div>
      <div class="mini-footer">
        <div class="row">
          <div class="decidim-logo">
            <a rel="decidim" href="https://decidim.org/" target="_blank">
              <%= image_tag("decidim/decidim-logo-mobile--inv.svg", alt: "Decidim Logo" ) %>
            </a>
          </div>
          <a rel="license" class="cc-badge"
             href="http://creativecommons.org/licenses/by-sa/4.0/"
             target="_blank">
            <%= image_tag("decidim/cc-by-sa--inv.svg", alt: "Creative Commons License" ) %>
          </a>
          <div class="mf-text">
            <%= t("layouts.decidim.footer.made_with_open_source").html_safe %>
          </div>
        </div>
      </div>
    </div><!--/.off-canvas-content-->
  </div><!--/.off-canvas-wrapper-inner-->
</div><!--/.off-canvas-wrapper-->

app/views/layouts/decidim/admin/_template_bottom.html.erb
</div><!--/.layout-wrapper-->
</main>

<%= render "support/helpscout" %>
<%= render "analytics/hotjar" %>

app/views/layouts/decidim/admin/settings.html.erb
<% content_for :secondary_nav do %>
  <div class="secondary-nav">
    <div class="secondary-nav__title">
      <%= t ".title" %>
    </div>
    <ul>
      <li <% if is_active_link?(decidim_admin.edit_organization_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.configuration", scope: "decidim.admin"), decidim_admin.edit_organization_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.edit_organization_appearance_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.appearance", scope: "decidim.admin"), decidim_admin.edit_organization_appearance_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.edit_organization_homepage_path, /^\/admin\/organization\/homepage/) %> class="is-active" <% end %>>
        <%= link_to t("menu.homepage", scope: "decidim.admin"), decidim_admin.edit_organization_homepage_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.navbar_links_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.navbar_links", scope: "decidim.admin"), decidim_admin.navbar_links_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.scopes_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.scopes", scope: "decidim.admin"), decidim_admin.scopes_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.scope_types_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.scope_types", scope: "decidim.admin"), decidim_admin.scope_types_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.areas_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.areas", scope: "decidim.admin"), decidim_admin.areas_path %>
      </li>
      <li <% if is_active_link?(decidim_admin.area_types_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.area_types", scope: "decidim.admin"), decidim_admin.area_types_path %>
      </li>
      <li <% if allowed_to?(:update, :help_sections) && is_active_link?(decidim_admin.help_sections_path) %> class="is-active" <% end %>>
        <%= link_to t("menu.help_sections", scope: "decidim.admin"), decidim_admin.help_sections_path %>
      </li>
      <li <% if is_active_link?(decidim_admin_polis.organization_configuration_edit_path) %> class="is-active" <% end %>>
        <%= link_to "Pol.is", decidim_admin_polis.organization_configuration_edit_path %>
      </li>
    </ul>
  </div>
<% end %>

<%= render "layouts/decidim/admin/application" do %>
  <%= yield %>
<% end %>

app/views/support/_beacon.html.erb
<script type="text/javascript">!function (e, t, n) {
    function a() {
        var e = t.getElementsByTagName("script")[0], n = t.createElement("script");
        n.type = "text/javascript", n.async = !0, n.src = "https://beacon-v2.helpscout.net", e.parentNode.insertBefore(n, e)
    }

    if (e.Beacon = n = function (t, n, a) {
        e.Beacon.readyQueue.push({method: t, options: n, data: a})
    }, n.readyQueue = [], "complete" === t.readyState) return a();
    e.attachEvent ? e.attachEvent("onload", a) : e.addEventListener("load", a, !1)
}(window, document, window.Beacon || function () {
});</script>
<script type="text/javascript">window.Beacon('init', '<%= beacon_id %>')</script>
<% if current_user %>
  <script type="text/javascript">
      Beacon("identify", {
          name: "<%= current_user.name %>",
          email: "<%= current_user.email %>",
          company: "<%= current_user.organization.name %>"
      });
  </script>
<% end %>

app/views/support/_helpscout.html.erb
<% if Rails.application.secrets.dig(:helpscout).present? && Rails.application.secrets.dig(:helpscout, :enabled) %>
  <% if Rails.application.secrets.dig(:helpscout, :fallback) %>
    <% if current_locale == "fr" %>
      <%= render partial: "support/beacon", locals: { beacon_id: Rails.application.secrets.dig(:helpscout, :main) } %>
    <% else %>
      <%= render partial: "support/beacon", locals: { beacon_id: Rails.application.secrets.dig(:helpscout, :fallback) } %>
    <% end %>
  <% else %>
    <%= render partial: "support/beacon", locals: { beacon_id: Rails.application.secrets.dig(:helpscout, :main) } %>
  <% end %>
<% end %>